local addonName,ns = ...
local L = ns.L
ns.CVarFrames = {TextFrames = {},Frames = {}}--记录CVar框体
ns.Y = {}	--用于分页行数自动拓展

--创建主页面点击放大分类按钮
local tabbutton = {}
function ns.AddClickBC(parent,frame, id, width, text, xOffset, yOffset)
	local xOffset = xOffset or 6
    local yOffset = yOffset or -2
    local prevButton = tabbutton[id - 1] -- 获取前一个按钮

    local button = CreateFrame("Button", nil, parent, "ColumnDisplayButtonTemplate")
    button:SetSize(width, 24) -- 如果不是24，右边框体会出问题
    if prevButton then
		frame:Hide()
        button:SetPoint("BOTTOMLEFT", prevButton["A"], "BOTTOMRIGHT", 10 ,0)
		button:SetScale(.9)
		button:GetFontString():SetTextColor(1, 1, 1)
    else
        button:SetPoint("BOTTOM", parent, "TOPLEFT", xOffset, yOffset)
		button:SetScale(1.1)
		button:GetFontString():SetTextColor(1, 1, 0)
    end
    button:SetText(text)
    button:GetFontString():SetPoint("TOPLEFT", button, "TOPLEFT", 0, 0)
    button:GetFontString():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 0, 0)
	
    tabbutton[id] = {}
	tabbutton[id]["A"] = button
	tabbutton[id]["B"] = frame
    button:SetScript("OnClick", function(self)
        for aa, row in pairs(tabbutton) do
            if self == row["A"] then -- 只对当前按钮重新定位
                row["A"]:SetScale(1.1)
				row["A"]:GetFontString():SetTextColor(1, 1, 0)
				row["B"]:Show()
            else
                row["A"]:SetScale(.9)
				row["A"]:GetFontString():SetTextColor(1, 1, 1)
				row["B"]:Hide()
            end
        end
    end)

    return button
end

--点击功能按钮
function ns.AddfuncButton(parent,point,name,x,y,width,height)
	local width = width or 110
	local height = height or 25
	local x = x or 500
	local y = y or 1
	local funcButton = CreateFrame("Button", nil, parent, "UIPanelButtonTemplate")
	funcButton:SetText(name)
	funcButton:SetSize(width,height)
	funcButton:SetPoint("LEFT",point,"LEFT", x, y)
	funcButton:SetScript("OnClick", function()end)
	return funcButton
end

--色块
function ns.AddColorFrame(parent, x, y, tip,width,height,DB,DB2,DB3)
	local parent = parent or UIParent	--父框体
	local x, y = x or 0, y or 0	--锚点坐标
	local r, g, b = 0, 1, 0
	local tip = tip or L["点击更改颜色"]
	local width,height = width or 75,height or 15
	if DB3 then
		r = PlateColorDB[DB][DB2][DB3]["r"]
		g = PlateColorDB[DB][DB2][DB3]["g"]
		b = PlateColorDB[DB][DB2][DB3]["b"]
	elseif DB2 then
		r = PlateColorDB[DB][DB2]["r"]
		g = PlateColorDB[DB][DB2]["g"]
		b = PlateColorDB[DB][DB2]["b"]
	elseif DB then
		r = PlateColorDB[DB]["r"]
		g = PlateColorDB[DB]["g"]
		b = PlateColorDB[DB]["b"]
	end

    parent.btn = CreateFrame("Button", nil, parent, "GameMenuButtonTemplate");
    parent.btn:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y);
    parent.btn:SetSize(width,height);
    parent.btn:SetAlpha(0)
    parent.btn:SetNormalFontObject("GameFontNormalLarge");
    parent.btn:SetHighlightFontObject("GameFontHighlightLarge");
	parent.btn.color = parent:CreateTexture(nil, "ARTWORK")
    parent.btn.color:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y)
    parent.btn.color:SetSize(width,height)
    parent.btn.color:SetColorTexture(r, g, b)
	
    local onUpdate = function(restore)
        local r, g, b = ColorPickerFrame:GetColorRGB()
        parent.btn.color:SetColorTexture(r, g, b)
		if DB3 then
			PlateColorDB[DB][DB2][DB3]["r"] = r
			PlateColorDB[DB][DB2][DB3]["g"] = g
			PlateColorDB[DB][DB2][DB3]["b"] = b
			PlateColorDB[DB][DB2]["set"] = true;
		elseif DB2 then
			PlateColorDB[DB][DB2]["r"] = r
			PlateColorDB[DB][DB2]["g"] = g
			PlateColorDB[DB][DB2]["b"] = b
		elseif DB then
			PlateColorDB[DB]["r"] = r
			PlateColorDB[DB]["g"] = g
			PlateColorDB[DB]["b"] = b
		end
    end
    local onCancel = function()
        local r, g, b = ColorPickerFrame:GetPreviousValues()
        parent.btn.color:SetColorTexture(r, g, b)
		if DB3 then
			PlateColorDB[DB][DB2][DB3]["r"] = r
			PlateColorDB[DB][DB2][DB3]["g"] = g
			PlateColorDB[DB][DB2][DB3]["b"] = b
		elseif DB2 then
			PlateColorDB[DB][DB2]["r"] = r
			PlateColorDB[DB][DB2]["g"] = g
			PlateColorDB[DB][DB2]["b"] = b
		elseif DB then
			PlateColorDB[DB]["r"] = r
			PlateColorDB[DB]["g"] = g
			PlateColorDB[DB]["b"] = b
		end
    end

    parent.btn:SetScript("OnClick", function(self, button, down)
       local r,g,b = r, g, b
       ColorPickerFrame.swatchFunc = onUpdate
       ColorPickerFrame.previousValues = {r = r, g = g, b = b}
       ColorPickerFrame.cancelFunc = onCancel
       ColorPickerFrame.Content.ColorPicker:SetColorRGB(r, g, b)
       ColorPickerFrame:Show()
    end)
    parent.btn:SetScript("OnEnter", function(self)
        GameTooltip:SetOwner(self, "ANCHOR_CURSOR ", 20, -20)
        GameTooltip:SetText(tip)
        GameTooltip:Show()
    end)
    parent.btn:SetScript("OnLeave", function(self)
        GameTooltip:Hide()
    end)
	return parent.btn
end

--创建主页面编辑框
function ns.AddEditBox(parent,x,y,size,Numeric,scale)
	local Box = CreateFrame("EditBox", nil, parent, "InputBoxTemplate")
	Box:SetSize(size, 30)
	Box:SetScale(scale or 1)
	Box:SetPoint("TOPLEFT", x,y)
	Box:SetAutoFocus(false)
	Box:SetNumeric(Numeric)
	local ClearBox = CreateFrame("Button", nil, Box)
	ClearBox:SetPoint("RIGHT", -5, 0)
	ClearBox:SetSize(13, 13)
	ClearBox:SetNormalTexture("common-search-clearbutton")
	ClearBox:SetHighlightTexture("common-search-clearbutton")
	Box:SetScript("OnEnterPressed", function() end)
	--Box:SetScript("OnTextChanged", function() end)
	Box:SetScript("OnTextChanged", function(self)
		ClearBox:SetShown(self:GetText() ~= "")
	end)
	ClearBox:SetScript("OnClick", function() Box:SetText("") Box:GetScript("OnTextChanged")(Box)  end)
	return Box
end

--创建主页面点击按钮
function ns.AddButtons(parent,name,x,y,width,height,Numeric,scale)
	local Button = CreateFrame("Button", nil, parent, "UIPanelButtonTemplate")
	Button:SetPoint("TOPLEFT", x,y)
	Button:SetSize(width,height)
	Button:SetText(name)
	Button:SetScript("OnClick", function() end)
	return Button
end

--设置主页面分类标题文本
function ns.AddSetTiText(parent,y,texts)
	local Text = parent:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	Text:SetPoint("TOPLEFT",parent,"TOPLEFT", 30, -20+ns.Y[y]*-35)
	Text:SetText(texts)
	Text:SetFont(ns.fonts, 20, "OUTLINE")
	Text:SetTextColor(1,1,1)
	ns.Y[y] = ns.Y[y] + 1	--最后增加一次起始位置
	return Text
end
--设置主页面点击按钮
function ns.AddSetClickB(parent,y,name,tip,db,cvar,spare1,spare2)
	local rowFrame = CreateFrame("Frame", nil, parent)
    rowFrame:SetSize(630, 26)
    rowFrame:SetPoint("TOPLEFT", 10, -10+ns.Y[y]*-35)
	local SliderBackground = rowFrame:CreateTexture(nil, "BACKGROUND")
	SliderBackground:SetTexture(130937)
	SliderBackground:SetAllPoints(rowFrame)
	SliderBackground:SetColorTexture(0, 0, 0, 0) -- 设置背景颜色为黑色，透明度为0.5
	SliderBackground:SetScript("OnEnter", function(self)
		self:SetColorTexture(0.5, 0.5, 0.5, .2)
	end)
	SliderBackground:SetScript("OnLeave", function(self)
		self:SetColorTexture(0, 0, 0, 0)
	end)
	local check = CreateFrame("CheckButton", nil, rowFrame, "InterfaceOptionsCheckButtonTemplate")
	check:SetPoint("LEFT",SliderBackground,"LEFT", 297, 0)
	check:SetSize(30,30)
	check:SetChecked(PlateColorDB[db])
	check:SetScript("OnEnter",function(self) 
		SliderBackground:SetColorTexture(0.5, 0.5, 0.5, .2)
		if tip then
			GameTooltip:SetOwner(SliderBackground, "ANCHOR_TOPRIGHT")
			GameTooltip:AddLine("|cffFFFFFF"..tip.."|r") 
			GameTooltip:Show()
		end
	end)
	check:SetScript("OnLeave", function(self)    
		SliderBackground:SetColorTexture(0, 0, 0, 0)
		if tip then
			GameTooltip:Hide()
		end
	end)
	
	check:SetScript("OnClick", function ( ... )
		PlateColorDB[db] = check:GetChecked()
		if InCombatLockdown() then return end
		if cvar and cvar == "nameplateShowOnlyNames" then
			ns.CteatNewPlateName()
			if check:GetChecked() then
				SetCVar(cvar, 1)
				C_Timer.After(0.1,function()--延迟设置,不然会被重置
					C_NamePlate.SetNamePlateFriendlySize(PlateColorDB.friendnpX,PlateColorDB.friendnpY)
				end)
			else
				SetCVar(cvar, 0)
			end
		elseif cvar then
			if check:GetChecked() then
				SetCVar(cvar, 1)
			else
				SetCVar(cvar, 0)
			end
		end
	end)
	local lefttext = rowFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	lefttext:SetPoint("LEFT", SliderBackground, "LEFT", 90, 0)
	lefttext:SetText(name)
	lefttext:SetFont(ns.fonts, 14, "OUTLINE")
	if cvar and cvar ~= "OUTLINE" then--如果是CVar设置字体颜色为绿色
		lefttext:SetTextColor(0,1,0)
		table.insert(ns.CVarFrames["TextFrames"], lefttext)
		table.insert(ns.CVarFrames["Frames"], check)
	else
		lefttext:SetTextColor(1,.82,0)
	end
		
	
	ns.Y[y] = ns.Y[y] + 1	--最后增加一次起始位置
	local cleckandtext = {}
	cleckandtext.text = lefttext
	cleckandtext.check = check
	return cleckandtext
	
end

--设置主页面滑动条
local OptionFrames = {}
local OptionFrameid = 1
function ns.AddSetSlider(parent,y, name, tip, minValue, maxValue, valueStep,varformat, db,cvar,spare)
	local rowFrame = CreateFrame("Frame", nil, parent)
    rowFrame:SetSize(630, 26)
    rowFrame:SetPoint("TOPLEFT", 10, -10+ns.Y[y]*-35)
	local SliderBackground = rowFrame:CreateTexture(nil, "BACKGROUND")
	SliderBackground:SetTexture(130937)
	SliderBackground:SetColorTexture(0, 0, 0, 0) -- 设置背景颜色为黑色，透明度为0.5
	SliderBackground:SetAllPoints(rowFrame)
	
	local PCSlider = CreateFrame("Slider", nil, rowFrame, "OptionsSliderTemplate")
	PCSlider:SetPoint("LEFT",SliderBackground,"LEFT", 300, 0)
	PCSlider:SetSize(220,20)
	PCSlider:SetMinMaxValues(minValue, maxValue)
	PCSlider:SetValue(PlateColorDB[db])
	PCSlider:SetValueStep(valueStep)
	PCSlider:SetObeyStepOnDrag(true)
	PCSlider.lefttext = PCSlider:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	PCSlider.lefttext:SetPoint("LEFT", SliderBackground, "LEFT", 90, 0)
	PCSlider.lefttext:SetText(name)
	PCSlider.lefttext:SetFont(ns.fonts, 14, "OUTLINE")
	PCSlider.righttext = PCSlider:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	PCSlider.righttext:SetPoint("LEFT",PCSlider,"RIGHT",10, 0)
	PCSlider.righttext:SetFont(ns.fonts, 17, "OUTLINE")
	PCSlider.righttext:SetTextColor(0,1,0)
	PCSlider.righttext:SetText(tonumber(string.format(varformat,PlateColorDB[db])))
	if cvar and cvar ~=1 then--如果是CVar设置字体颜色为绿色
		PCSlider.lefttext:SetTextColor(0,1,0)
		table.insert(ns.CVarFrames["TextFrames"], PCSlider.lefttext)
		table.insert(ns.CVarFrames["TextFrames"], PCSlider.righttext)
		table.insert(ns.CVarFrames["Frames"], PCSlider)
	else
		PCSlider.lefttext:SetTextColor(1,.82,0)
	end
	PCSlider.Low:Hide()
	PCSlider.High:Hide()
	PCSlider:SetScript("OnValueChanged", function(self, value)
		self.righttext:SetText(string.format(varformat,value))
		PlateColorDB[db] = tonumber(string.format(varformat,value))
		if InCombatLockdown() then return end
		if cvar and cvar == "nameplateMaxAlpha" then--如果是非当前目标透明度
			SetCVar(cvar, value)
			SetCVar(spare, value)
		elseif cvar and cvar == 1 then--如果是1则处理友方名字
			ns.CteatNewPlateName()
		elseif cvar and cvar == 2 then--如果是2则是友方血条尺寸,备注是另一项
			C_NamePlate.SetNamePlateFriendlySize(PlateColorDB[db],PlateColorDB[spare])
		elseif cvar and cvar == 3 then--如果是3则是友方姓名版上下,备注是另一项
			C_NamePlate.SetNamePlateFriendlySize(PlateColorDB[spare],PlateColorDB[db])
		elseif cvar then
			SetCVar(cvar, value)	--如果是cvar执行一次
		end

	end)
	SliderBackground:SetScript("OnEnter", function(self)
		self:SetColorTexture(0.5, 0.5, 0.5, .2)
	end)
	SliderBackground:SetScript("OnLeave", function(self)
		self:SetColorTexture(0, 0, 0, 0)
	end)
	PCSlider:SetScript("OnEnter",function(self)
		SliderBackground:SetColorTexture(0.5, 0.5, 0.5, .2)
		if tip then
			GameTooltip:SetOwner(SliderBackground, "ANCHOR_TOPRIGHT") 
			GameTooltip:AddLine("|cffFFFFFF"..tip.."|r") 
			GameTooltip:Show()
		end
	end)
	PCSlider:SetScript("OnLeave", function(self)
		SliderBackground:SetColorTexture(0, 0, 0, 0)
		if tip then
			GameTooltip:Hide()
		end
	end)
	ns.Y[y] = ns.Y[y] + 1	--最后增加一次起始位置
	local PCSliders = {}
	PCSliders.check = PCSlider
	PCSliders.text = PCSlider.lefttext
	PCSliders.righttext = PCSlider.righttext
	return PCSliders
end

--设置主页面材质下拉菜单
function ns.AddSetDropdTexture(parent,y,name,tip,db)
	local rowFrame = CreateFrame("Frame", nil, parent)
    rowFrame:SetSize(630, 26)
    rowFrame:SetPoint("TOPLEFT", 10, -10+ns.Y[y]*-35)
	local SliderBackground = rowFrame:CreateTexture(nil, "BACKGROUND")
	SliderBackground:SetTexture(130937)
	SliderBackground:SetColorTexture(0, 0, 0, 0) -- 设置背景颜色为黑色，透明度为0.5
	SliderBackground:SetAllPoints(rowFrame)
	
	local lefttext = rowFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	lefttext:SetPoint("LEFT", SliderBackground, "LEFT", 90, 0)
	lefttext:SetText(name)
	lefttext:SetFont(ns.fonts, 14, "OUTLINE")
	lefttext:SetTextColor(1,.82,0)

	local cpHpstatusbar = rowFrame:CreateTexture(nil, "ARTWORK")
	cpHpstatusbar:SetPoint("RIGHT",rowFrame,"RIGHT", -5, 0)
	cpHpstatusbar:SetSize(152,13)
	cpHpstatusbar:SetVertexColor(1,0,0,1)
	cpHpstatusbar:EnableMouse()
	local cpHpstatusbarBG = CreateFrame("Frame", nil, rowFrame, "BackdropTemplate")
	cpHpstatusbarBG:SetPoint("TOPLEFT",cpHpstatusbar,"TOPLEFT",-1,1.5)
	cpHpstatusbarBG:SetPoint("BOTTOMRIGHT",cpHpstatusbar,"BOTTOMRIGHT",1.5,-1)
	cpHpstatusbarBG:SetBackdrop{edgeFile = 'Interface\\Buttons\\WHITE8x8',edgeSize = 2}
	cpHpstatusbarBG:SetBackdropBorderColor(.5, .5, .5, 1)
	if ns.HpTextures[PlateColorDB.hpTexture] then
		cpHpstatusbar:SetTexture(ns.HpTextures[PlateColorDB.hpTexture])
	else
		cpHpstatusbar:SetTexture(ns.HpTextures["PlateColor"])
	end
	SliderBackground:SetScript("OnEnter", function(self)
		self:SetColorTexture(0.5, 0.5, 0.5, .2)
		cpHpstatusbarBG:SetBackdropBorderColor(1, 1, 1, 1)
	end)
	SliderBackground:SetScript("OnLeave", function(self)
		self:SetColorTexture(0, 0, 0, 0)
		cpHpstatusbarBG:SetBackdropBorderColor(.5, .5, .5, 1)
	end)

	local notexturename = L["不修改材质"]
	local dropdown = CreateFrame("Frame", nil, rowFrame, "UIDropDownMenuTemplate")
		dropdown:SetPoint("LEFT",SliderBackground,"LEFT", 282, -2) -- 设置下拉菜单的位置
		UIDropDownMenu_SetWidth(dropdown, 150)
		if PlateColorDB[db] == "noHpTexture" then
			UIDropDownMenu_SetText(dropdown, notexturename) -- 设置下拉菜单显示的文本为默认选项的文本
		else
			UIDropDownMenu_SetText(dropdown, PlateColorDB[db])
		end
		-- 设置下拉菜单的初始化函数
		UIDropDownMenu_Initialize(dropdown, function(self, level, menuList)
		local info = UIDropDownMenu_CreateInfo()
        -- 遍历选项并添加到下拉菜单中
        for index, optionText in pairs(ns.HpTextures) do
			if index == "noHpTexture" or index == "PlateColor" or index == "Rainbow" then
				info.colorCode = "|cff00FFFF"
			else
				info.colorCode = ""
			end
			if index == "noHpTexture" then
				info.text = L["不修改材质"]
			else
				info.text = index
			end
			info.icon = optionText
            info.checked = index == PlateColorDB[db]  -- 只有与 db 相等的选项会被选中
            info.func = function()
				-- 更新 db 的值
				if index == "noHpTexture" then
					UIDropDownMenu_SetText(dropdown, notexturename)
				else
					UIDropDownMenu_SetText(dropdown, index) -- 更新下拉菜单的显示文本
				end
				PlateColorDB[db] = index
				cpHpstatusbar:SetTexture(ns.HpTextures[PlateColorDB.hpTexture])
                CloseDropDownMenus()
            end
            UIDropDownMenu_AddButton(info, level)
		end
	end)
		
		ns.Y[y] = ns.Y[y] + 1	--最后增加一次起始位置
	return check
end

--设置主页面下拉菜单
function ns.AddSetDropdM(parent,y,name,tip,optionstext,db)
	local rowFrame = CreateFrame("Frame", nil, parent)
    rowFrame:SetSize(630, 26)
    rowFrame:SetPoint("TOPLEFT", 10, -10+ns.Y[y]*-35)
	local SliderBackground = rowFrame:CreateTexture(nil, "BACKGROUND")
	SliderBackground:SetTexture(130937)
	SliderBackground:SetColorTexture(0, 0, 0, 0) -- 设置背景颜色为黑色，透明度为0.5
	SliderBackground:SetAllPoints(rowFrame)
	SliderBackground:SetScript("OnEnter", function(self)
		self:SetColorTexture(0.5, 0.5, 0.5, .2)
	end)
	SliderBackground:SetScript("OnLeave", function(self)
		self:SetColorTexture(0, 0, 0, 0)
	end)
	
	local lefttext = rowFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	lefttext:SetPoint("LEFT", SliderBackground, "LEFT", 90, 0)
	lefttext:SetText(name)
	lefttext:SetFont(ns.fonts, 14, "OUTLINE")
	lefttext:SetTextColor(1,.82,0)

	local dropdown = CreateFrame("Frame", nil, rowFrame, "UIDropDownMenuTemplate")
		dropdown:SetPoint("LEFT",SliderBackground,"LEFT", 282, 0) -- 设置下拉菜单的位置
		UIDropDownMenu_SetText(dropdown, optionstext[PlateColorDB[db]]) -- 设置下拉菜单显示的文本为默认选项的文本
		-- 设置下拉菜单的初始化函数
		UIDropDownMenu_Initialize(dropdown, function(self, level, menuList)
		local info = UIDropDownMenu_CreateInfo()
        -- 遍历选项并添加到下拉菜单中
        for index, optionText in ipairs(optionstext) do
            info.text = optionText
            info.checked = index == PlateColorDB[db]  -- 只有与 db 相等的选项会被选中
            info.func = function()
                -- 更新 db 的值
                PlateColorDB[db] = index
                UIDropDownMenu_SetText(dropdown, optionText) -- 更新下拉菜单的显示文本
                CloseDropDownMenus()
            end
            UIDropDownMenu_AddButton(info, level)
		end
	end)
		
		ns.Y[y] = ns.Y[y] + 1	--最后增加一次起始位置
	return check
end

--设置主页面界面颜色选项
function ns.AddSetColorF(parent,y,name,tip,DB,DB2,DB3)
	local rowFrame = CreateFrame("Frame", nil, parent)
    rowFrame:SetSize(630, 26)
    rowFrame:SetPoint("TOPLEFT", 10, -10+ns.Y[y]*-35)
	local SliderBackground = rowFrame:CreateTexture(nil, "BACKGROUND")
	SliderBackground:SetTexture(130937)
	SliderBackground:SetAllPoints(rowFrame)
	SliderBackground:SetColorTexture(0, 0, 0, 0) -- 设置背景颜色为黑色，透明度为0.5
	SliderBackground:SetAllPoints(rowFrame)
	SliderBackground:SetScript("OnEnter", function(self)
		self:SetColorTexture(0.5, 0.5, 0.5, .2)
	end)
	SliderBackground:SetScript("OnLeave", function(self)
		self:SetColorTexture(0, 0, 0, 0)
	end)
	
	local lefttext = rowFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	lefttext:SetPoint("LEFT", SliderBackground, "LEFT", 90, 0)
	lefttext:SetText(name)
	lefttext:SetFont(ns.fonts, 14, "OUTLINE")
	lefttext:SetTextColor(1,.82,0)
	
	local Color = ns.AddColorFrame(rowFrame, 301, -3, "",150,20,DB,DB2,DB3)
	Color:HookScript("OnEnter", function(self)
		SliderBackground:SetColorTexture(0.5, 0.5, 0.5, .2)
		if tip then
			GameTooltip:SetOwner(SliderBackground, "ANCHOR_TOPRIGHT") 
			GameTooltip:AddLine("|cffFFFFFF"..tip.."|r") 
			GameTooltip:Show()
		end
	end)
	Color:HookScript("OnLeave", function(self)
		SliderBackground:SetColorTexture(0, 0, 0, 0)
		if tip then
			GameTooltip:Hide()
		end
	end)
	
	ns.Y[y] = ns.Y[y] + 1	--最后增加一次起始位置
	
	return Color
end

--设置主页面创建表格分类按钮分类
function ns.AddClassB(parent,text,width,x,y,func)
	local y = y or -2
	local button1 = CreateFrame("Button", nil, parent, "ColumnDisplayButtonTemplate")
	button1:SetSize(width,24)--不是24右边框体会出问题
	button1:SetPoint("BOTTOMLEFT", parent, "TOPLEFT",x,y)
	button1:SetText(text)
	button1:GetFontString():SetPoint("TOPLEFT", button1, "TOPLEFT", 0, 0)
	button1:GetFontString():SetPoint("BOTTOMRIGHT", button1, "BOTTOMRIGHT", 0, 0)
	button1:SetScript("OnClick", func or (function() end))
	return button1
end

-- 创建多选下拉菜单的函数
local function CreateDropdownMenu(parent,x,y,db)
    local dropdown = CreateFrame("Frame", nil, parent, "UIDropDownMenuTemplate")
    dropdown:SetPoint("LEFT",x,y) -- 设置下拉菜单的位置
	UIDropDownMenu_SetText(dropdown, "选项")
    
    -- 设置下拉菜单的初始化函数
    UIDropDownMenu_Initialize(dropdown, function(self, level, menuList)
        local info = UIDropDownMenu_CreateInfo()

        -- 遍历选项并添加到下拉菜单中
        for _, optionData in pairs(db) do
            info.text = optionData.text
            info.checked = optionData.checked
            info.func = function() 
                -- 更新dropDB的值
                optionData.checked = not optionData.checked
                ToggleDropDownMenu(1, nil, dropdown)
            end
            UIDropDownMenu_AddButton(info, level)
        end
    end)
end